import { createInfoSection as publicCreateInfoSection, getInfoSection as publicGetInfoSection, getOrCreateInfoSection as publicGetOrCreateInfoSection, bulkGetOrCreateInfoSections as publicBulkGetOrCreateInfoSections, updateInfoSection as publicUpdateInfoSection, deleteInfoSection as publicDeleteInfoSection, queryInfoSections as publicQueryInfoSections, bulkCreateInfoSections as publicBulkCreateInfoSections, bulkUpdateInfoSections as publicBulkUpdateInfoSections, bulkDeleteInfoSections as publicBulkDeleteInfoSections } from './stores-catalog-v3-info-section-info-sections-v-3.public.js';
import { createEventModule } from '@wix/sdk-runtime/event-definition-modules';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
import { onInfoSectionCreated as publicOnInfoSectionCreated } from './stores-catalog-v3-info-section-info-sections-v-3.public.js';
import { onInfoSectionDeleted as publicOnInfoSectionDeleted } from './stores-catalog-v3-info-section-info-sections-v-3.public.js';
import { onInfoSectionUpdated as publicOnInfoSectionUpdated } from './stores-catalog-v3-info-section-info-sections-v-3.public.js';
export declare const createInfoSection: MaybeContext<BuildRESTFunction<typeof publicCreateInfoSection> & typeof publicCreateInfoSection>;
export declare const getInfoSection: MaybeContext<BuildRESTFunction<typeof publicGetInfoSection> & typeof publicGetInfoSection>;
export declare const getOrCreateInfoSection: MaybeContext<BuildRESTFunction<typeof publicGetOrCreateInfoSection> & typeof publicGetOrCreateInfoSection>;
export declare const bulkGetOrCreateInfoSections: MaybeContext<BuildRESTFunction<typeof publicBulkGetOrCreateInfoSections> & typeof publicBulkGetOrCreateInfoSections>;
export declare const updateInfoSection: MaybeContext<BuildRESTFunction<typeof publicUpdateInfoSection> & typeof publicUpdateInfoSection>;
export declare const deleteInfoSection: MaybeContext<BuildRESTFunction<typeof publicDeleteInfoSection> & typeof publicDeleteInfoSection>;
export declare const queryInfoSections: MaybeContext<BuildRESTFunction<typeof publicQueryInfoSections> & typeof publicQueryInfoSections>;
export declare const bulkCreateInfoSections: MaybeContext<BuildRESTFunction<typeof publicBulkCreateInfoSections> & typeof publicBulkCreateInfoSections>;
export declare const bulkUpdateInfoSections: MaybeContext<BuildRESTFunction<typeof publicBulkUpdateInfoSections> & typeof publicBulkUpdateInfoSections>;
export declare const bulkDeleteInfoSections: MaybeContext<BuildRESTFunction<typeof publicBulkDeleteInfoSections> & typeof publicBulkDeleteInfoSections>;
/**
 * Triggered when an info section is created.
 */
export declare const onInfoSectionCreated: ReturnType<typeof createEventModule<typeof publicOnInfoSectionCreated>>;
/**
 * Triggered when an info section is deleted.
 */
export declare const onInfoSectionDeleted: ReturnType<typeof createEventModule<typeof publicOnInfoSectionDeleted>>;
/**
 * Triggered when an info section is updated.
 */
export declare const onInfoSectionUpdated: ReturnType<typeof createEventModule<typeof publicOnInfoSectionUpdated>>;
export { NodeType, WidthType, PluginContainerDataAlignment, Type, Target, TextAlignment, LineStyle, Width, Alignment, ViewMode, LayoutType, Orientation, Crop, ThumbnailsAlignment, GIFType, Source, Position, MapType, ViewRole, VoteRole, PollLayoutType, PollLayoutDirection, BackgroundType, DecorationType, FontType, AppType, InitialExpandedItems, Direction, VerticalAlignment, NullValue, RequestedFields, SortOrder, WebhookIdentityType, } from './stores-catalog-v3-info-section-info-sections-v-3.universal.js';
export { InfoSection, RichContent, Node, NodeDataOneOf, NodeStyle, ButtonData, Border, Colors, PluginContainerData, PluginContainerDataWidth, PluginContainerDataWidthDataOneOf, Spoiler, Height, Styles, Link, LinkDataOneOf, Rel, CodeBlockData, TextStyle, DividerData, FileData, FileSource, FileSourceDataOneOf, PDFSettings, GalleryData, Media, Image, Video, Item, ItemDataOneOf, GalleryOptions, Layout, ItemStyle, Thumbnails, GIFData, GIF, HeadingData, HTMLData, HTMLDataDataOneOf, ImageData, StylesBorder, ImageDataStyles, LinkPreviewData, LinkPreviewDataStyles, MapData, MapSettings, ParagraphData, PollData, Permissions, Option, Settings, PollLayout, OptionLayout, Gradient, Background, BackgroundBackgroundOneOf, PollDesign, OptionDesign, Poll, PollDataLayout, Design, TextData, Decoration, DecorationDataOneOf, AnchorData, ColorData, LinkData, MentionData, FontSizeData, SpoilerData, AppEmbedData, AppEmbedDataAppDataOneOf, BookingData, EventData, VideoData, PlaybackOptions, EmbedData, Oembed, CollapsibleListData, TableData, Dimensions, TableCellData, CellStyle, BorderColors, ListValue, AudioData, OrderedListData, BulletedListData, BlockquoteData, CaptionData, LayoutCellData, Metadata, DocumentStyle, TextNodeStyle, InvalidateCache, InvalidateCacheGetByOneOf, App, Page, URI, File, CustomTag, CreateInfoSectionRequest, CreateInfoSectionResponse, GetInfoSectionRequest, GetInfoSectionResponse, GetOrCreateInfoSectionRequest, InfoSectionForGetOrCreate, GetOrCreateInfoSectionResponse, BulkGetOrCreateInfoSectionsRequest, BulkGetOrCreateInfoSectionsResponse, BulkInfoSectionItemResult, ItemMetadata, ApplicationError, BulkActionMetadata, UpdateInfoSectionRequest, UpdateInfoSectionResponse, DeleteInfoSectionRequest, DeleteInfoSectionResponse, QueryInfoSectionsRequest, CursorQuery, CursorQueryPagingMethodOneOf, Sorting, CursorPaging, QueryInfoSectionsResponse, CursorPagingMetadata, Cursors, BulkCreateInfoSectionsRequest, BulkCreateInfoSectionsResponse, BulkUpdateInfoSectionsRequest, MaskedInfoSection, BulkUpdateInfoSectionsResponse, BulkDeleteInfoSectionsRequest, BulkDeleteInfoSectionsResponse, BulkInfoSectionResult, DomainEvent, DomainEventBodyOneOf, EntityCreatedEvent, RestoreInfo, EntityUpdatedEvent, EntityDeletedEvent, ActionEvent, Empty, MessageEnvelope, IdentificationData, IdentificationDataIdOneOf, BaseEventMetadata, EventMetadata, InfoSectionCreatedEnvelope, InfoSectionDeletedEnvelope, InfoSectionUpdatedEnvelope, GetInfoSectionOptions, GetOrCreateInfoSectionOptions, BulkGetOrCreateInfoSectionsOptions, UpdateInfoSection, UpdateInfoSectionOptions, QueryInfoSectionsOptions, InfoSectionsQueryResult, InfoSectionsQueryBuilder, BulkCreateInfoSectionsOptions, BulkUpdateInfoSectionsOptions, } from './stores-catalog-v3-info-section-info-sections-v-3.universal.js';
